#include <errno.h>
#include <stdio.h>
#include <net/bsdlib.h>
#include <kernel.h>
#include <net/socket.h>
#include <at_cmd.h>
#include <lte_lc.h>

#define PORT 22
#define IPADDR "8.8.8.8"

#include <logging/log.h>

/* Initialize module-specific magic state (once per module name): */
LOG_MODULE_REGISTER();

int clientInit()
{
    int fd, ret;
    struct sockaddr_in bind_addr;

    fd = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    if (fd < 0) {
        printk("error: socket: %d\n", errno);
        return -1;
    } else {
		printk("Socket successfully created!\n");
	}

    bind_addr.sin_family = AF_INET;
	inet_pton(AF_INET, IPADDR, &bind_addr.sin_addr.s_addr);
    bind_addr.sin_port = htons(PORT);

	ret = connect(fd, (struct sockaddr*)&bind_addr, sizeof(bind_addr));
	if (ret < 0) {
		printk("ERROR CONNECTING RET: %d ERRNO: %d\n", ret, errno);
        return ret;
	}
    return fd;
}

static void modem_configure(void)
{
#if defined(CONFIG_LTE_LINK_CONTROL)
	if (IS_ENABLED(CONFIG_LTE_AUTO_INIT_AND_CONNECT)) {
		/* Do nothing, modem is already turned on
		 * and connected.
		 */
	} else {
		int err;

		printk("LTE Link Connecting ...\n");
		err = lte_lc_init_and_connect();
		__ASSERT(err == 0, "LTE link could not be established.");
		printk("LTE Link Connected!\n");
	}
#endif
}

int main(void) {

    printk("Modem Configure\n");
    modem_configure();

    int fd = clientInit();
    if (fd < 0) {
        printk("Client Init err %d\n", fd);
        return fd;
    }

    char buf[] = "Hallo Welt!\n";

    int out_len = send(fd, buf, sizeof(buf), 0);
    if (out_len < 0) {
        printk("error: send: %d\n", errno);
    }

	while (1) {
		k_sleep(500);
        printk("Waiting...\n");
	}
}
